# emotion

#### `css` prop for all

[![npm version](https://badge.fury.io/js/emotion.svg)](https://badge.fury.io/js/emotion)
[![Build Status](https://travis-ci.org/tkh44/emotion.svg?branch=master)](https://travis-ci.org/tkh44/emotion)
[![codecov](https://codecov.io/gh/tkh44/emotion/branch/master/graph/badge.svg)](https://codecov.io/gh/tkh44/emotion)


-   [Install](#install)
-   [glam](#emotionglam)
-   [glamor](#emotionglamor)
-   [cxs](#emotioncxs)

## Install

```bash
npm install -S emotion
```

## `emotion/glam`

```bash
npm install -S glam
```

**.babelrc**
```json
{
  "plugins": [
    "emotion/glam",
    "glam/babel"
  ]
}
```

```jsx harmony
const Name = ({ color, name }) => <h1 css={`color: ${color};`}>{name}</h1>
```

is converted to

```jsx harmony
const Name = ({ color, name }) => <h1 className={css`color: ${color};`}>{name}</h1>
```


**Similar to importing React when using jsx, `import css from 'glam'` must be at the top of your source files.**

## `emotion/glamor`

```bash
npm install -S glamor
```

**.babelrc**
```json
{
  "plugins": [
    "emotion/glamor",
  ]
}
```

```jsx harmony
const Name = ({ color, name }) => <h1 css={{ color: 'red' }}>{name}</h1>
```

is converted to

```jsx harmony
const Name = ({ color, name }) => <h1 {...css({color: 'red' })}>{name}</h1>
```


**Similar to importing React when using jsx, `import {css} from 'glamor'` must be at the top of your source files.**

## `emotion/cxs`

```bash
npm install -S cxs
```

**.babelrc**
```json
{
  "plugins": [
    "emotion/cxs",
  ]
}
```

```jsx harmony
const Name = ({ color, name }) => <h1 css={{ color: 'red', background: color }}>{name}</h1>
```

is converted to

```jsx harmony
const Name = ({ color, name }) => <h1 className={cxs({color: 'red', background: color })}>{name}</h1>
```


**Similar to importing React when using jsx, `import cxs from 'cxs'` must be at the top of your source files.**

